// tstinher.cpp -- demonstrate inheritance

#include "inherit.hpp"

void main() {

  cout << "\nTest inheritance\n\n";
  cout << "-- begin construction --\n";
  base b1("b1");
  base b2 = "b2";
  base b3;
  cout << "-- use operator+ on base objects --\n";
  b3 = b1 + b2;
  cout << "this is object b3: " << b3 << "\n";
  cout << "-- call fun using base object --\n";
  b3.fun();
  cout << "-- construct derived objects --\n";
  derived d1("d1");
  derived d2 = "d2";
  derived d3;
  cout << "-- use operator+ on derived objects --\n";
  d3 = d1 + d2;
  cout << "this is object d3: " << d3 << "\n";
  cout << "-- call fun using derived object --\n";
  d3.fun();        // no compile error, d is a base type
  cout << "-- call newfun using derived object --\n";
  d3.newfun();
  // b3.newfun();  // compile time error, b3 is not a derived type
}